(ns unit.jobtech-taxonomy.api.routes.documentation-test
  (:require [clojure.string :as str]
            [clojure.test :as test :refer [deftest is testing]]
            [jobtech-taxonomy.api.handler :as handler]
            [ring.mock.request :as rmr]
            [ring.util.http-predicates :as hp]
            [taoensso.timbre :as log]
            [utils.db-fixtures :as udf]))

(test/use-fixtures :each
  (fn [fun-run]
    (log/with-merged-config
      {:min-level [[#{"io.methvin.watcher.*"} :info]
                   [#{"datahike.*"} :info]
                   [#{"jobtech-taxonomy.api.db.database-connection"} :warn]
                   [#{"*"} :info]]}
      (fun-run)))
  (udf/database-minimal udf/cfg))

(def services-endpoint
  (handler/app udf/cfg))

(deftest static-files-test
  (testing "GET empty path"
    (let [path ""
          response (services-endpoint (rmr/request :get path))]
      (is (hp/found? response))
      (is (= "/index.html" (get-in response [:headers "Location"])))))
  (testing "GET /index.html"
    (let [path "/index.html"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (str/starts-with? (slurp (:body response)) "<!DOCTYPE html>"))))
  (testing "GET /favicon.ico"
    (let [path "/favicon.ico"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (some? (:body response)))))
  (testing "GET /favicon.ico"
    (let [path "/favicon.ico"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (some? (:body response))))))

(deftest swagger-ui-test
  (testing "GET /v1/taxonomy/swagger-ui"
    (let [path "/v1/taxonomy/swagger-ui"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/found? response))
      (is (= "/v1/taxonomy/swagger-ui/index.html" (get-in response [:headers "Location"])))))

  (testing "GET /v1/taxonomy/swagger-ui/index.html"
    (let [path "/v1/taxonomy/swagger-ui/index.html"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (str/starts-with? (slurp (:body response)) "<!-- HTML for static distribution bundle build -->\n<!DOCTYPE html>"))))

  (testing "GET /img/curl-logo.svg"
    (let [path "/img/curl-logo.svg"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (some? (:body response)))))

  (testing "GET /img/wget-logo.svg"
    (let [path "/img/wget-logo.svg"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (some? (:body response))))))

(deftest graphiql-test
  (testing "GET /v1/taxonomy/graphiql"
    (let [path "/v1/taxonomy/graphiql"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (str/starts-with? (slurp (:body response)) "<!--\n *  Copyright (c) 2021 GraphQL Contributors"))))

  (testing "GET /v1/taxonomy/graphiql.json"
    (let [path "/v1/taxonomy/graphiql.json"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (= "{\"url\":\"/v1/taxonomy/graphql\"}" (slurp (:body response)))))))

(deftest graphviz-test
  (testing "GET /v1/taxonomy/graphviz/types.svg"
    (let [path "/v1/taxonomy/graphviz/types.svg"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (str/includes? (:body response) "Generated by graphviz")))))

(deftest loaderio-test
  (testing "GET /loaderio-d59a5e945a6f4a6b924e388e4fc3c744.txt"
    (let [path "/loaderio-d59a5e945a6f4a6b924e388e4fc3c744.txt"
          response (services-endpoint (rmr/request :get path))]
      (is (hp/ok? response))
      (is (= (slurp (:body response)) "loaderio-d59a5e945a6f4a6b924e388e4fc3c744\n")))))